"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiButtons = require("@instructure/ui-buttons");

var _uiElements = require("@instructure/ui-elements");

var _uiForms = require("@instructure/ui-forms");

var _uiA11y = require("@instructure/ui-a11y");

var _Bank = _interopRequireDefault(require("../../../common/records/Bank"));

var _BankSelection = _interopRequireDefault(require("../../../common/components/resources/BankSelection"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _quizCommon = require("@instructure/quiz-common");

var _ref =
/*#__PURE__*/
_react.default.createElement("br", null);

var AddToBankModal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(AddToBankModal, _Component);

  function AddToBankModal() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, AddToBankModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(AddToBankModal)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      bankType: 'existing',
      newBankTitle: ''
    };

    _this.addToBank = function (bankId) {
      _this.props.getEntry().then(function (entry) {
        return _this.props.createBankEntry(bankId, _this.props.entryType, entry.id);
      }).then(_this.props.onAdd);
    };

    _this.continueAction = function () {
      _this.props.closeModal();

      _this.props.onContinue();

      if (_this.state.bankType === 'new') {
        var newBank = _Bank.default.create({
          title: _this.state.newBankTitle,
          language: _this.context.locale
        });

        _this.props.createBank(newBank).then(function (bankData) {
          _this.addToBank(bankData.id);
        });
      } else {
        _this.addToBank(_this.props.selectedBank.id);
      }
    };

    _this.closeAction = function () {
      _this.props.closeModal();
    };

    _this.onBankSelection = function (e, option) {
      _this.props.uiSet(_quizCommon.ADD_TO_BANK_MODAL_BANK_SELECTION, option.value);
    };

    _this.handleRadioChange = function (event, value) {
      _this.setState({
        bankType: value
      });
    };

    _this.onTitleChange = function (e) {
      _this.setState({
        newBankTitle: e.target.value
      });
    };

    return _this;
  }

  (0, _createClass2.default)(AddToBankModal, [{
    key: "cancelButton",
    value: function cancelButton() {
      return _react.default.createElement(_uiButtons.Button, {
        onClick: this.closeAction,
        margin: _quizCommon.XSMALL_SIDE_MARGIN
      }, (0, _formatMessage.default)('Cancel'));
    }
  }, {
    key: "addToBankButton",
    value: function addToBankButton() {
      var _this$state = this.state,
          bankType = _this$state.bankType,
          newBankTitle = _this$state.newBankTitle;
      var disabled = bankType === 'existing' && !this.props.selectedBank || bankType === 'new' && (!newBankTitle || !newBankTitle.trim());
      return _react.default.createElement(_uiButtons.Button, {
        type: "button",
        variant: "primary",
        onClick: this.continueAction,
        disabled: disabled,
        margin: _quizCommon.XSMALL_SIDE_MARGIN,
        "data-automation": "sdk-add-to-bank-button"
      }, (0, _formatMessage.default)('Add'));
    }
  }, {
    key: "renderBankTypeContent",
    value: function renderBankTypeContent() {
      if (this.state.bankType === 'existing') {
        return _react.default.createElement(_BankSelection.default, {
          onBankSelection: this.onBankSelection,
          selectedBank: this.props.selectedBank,
          "data-automation": "sdk-bank-selection",
          visibleOptionsCount: 3
        });
      }

      return _react.default.createElement(_uiForms.TextInput, {
        onChange: this.onTitleChange,
        value: this.state.newBankTitle,
        label: (0, _formatMessage.default)('New Bank Title'),
        type: "text"
      });
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      return _react.default.createElement("div", null, _react.default.createElement(_uiForms.RadioInputGroup, {
        onChange: this.handleRadioChange,
        name: (0, _formatMessage.default)('Bank Type'),
        defaultValue: this.state.bankType,
        description: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Bank Type'))
      }, _react.default.createElement(_uiForms.RadioInput, {
        value: "existing",
        label: (0, _formatMessage.default)('Existing item bank')
      }), _react.default.createElement(_uiForms.RadioInput, {
        value: "new",
        label: (0, _formatMessage.default)('New item bank')
      })), _ref, this.renderBankTypeContent());
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_quizCommon.Modal, {
        open: this.props.modalOpen,
        onDismiss: this.closeAction,
        size: "small",
        label: this.props.label,
        "data-automation": "sdk-add-to-bank-modal"
      }, _react.default.createElement(_quizCommon.ModalHeader, null, _react.default.createElement(_uiElements.Heading, {
        level: "reset",
        as: "h2"
      }, this.props.label), _react.default.createElement(_uiButtons.CloseButton, {
        onClick: this.closeAction,
        placement: "end",
        offset: "medium",
        variant: "icon"
      }, (0, _formatMessage.default)('Close'))), _react.default.createElement(_quizCommon.ModalBody, null, this.renderContent()), _react.default.createElement(_quizCommon.ModalFooter, null, this.cancelButton(), this.addToBankButton()));
    }
  }]);
  AddToBankModal.displayName = "AddToBankModal";
  return AddToBankModal;
}(_react.Component);

exports.default = AddToBankModal;
AddToBankModal.propTypes = {
  closeModal: _propTypes.default.func.isRequired,
  createBank: _propTypes.default.func.isRequired,
  createBankEntry: _propTypes.default.func.isRequired,
  // Create the bank entry's entry, or clone it if it already exists. Should
  // always be provided when a source is provided.
  // eslint-disable-next-line react/no-unused-prop-types
  entryId: _propTypes.default.string.isRequired,
  // Only present for use in modalOpen key
  entryType: _propTypes.default.string.isRequired,
  // Resolve to the bank entry's entry, or create it if it does not yet exist.
  getEntry: _propTypes.default.func.isRequired,
  label: _propTypes.default.string.isRequired,
  modalOpen: _propTypes.default.bool.isRequired,
  onAdd: _propTypes.default.func,
  onContinue: _propTypes.default.func,
  selectedBank: _reactImmutableProptypes.default.record,
  uiSet: _propTypes.default.func.isRequired
};
AddToBankModal.defaultProps = {
  onAdd: function onAdd() {},
  onContinue: function onContinue() {},
  selectedBank: null
};
AddToBankModal.contextTypes = {
  locale: _propTypes.default.string
};