"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.disassociateQuizEntry = exports.associateQuizEntries = exports.associateQuizAnalysis = exports.associateItemAnalyses = exports.newActiveQuiz = exports.addQuizzes = void 0;

var _quizCommon = require("@instructure/quiz-common");

var addQuizzes = function addQuizzes(quizzes) {
  return {
    type: _quizCommon.ADD_QUIZZES,
    payload: quizzes
  };
};

exports.addQuizzes = addQuizzes;

var newActiveQuiz = function newActiveQuiz(activeQuizId) {
  return {
    type: _quizCommon.ACTIVE_QUIZ_CHANGE,
    payload: activeQuizId
  };
};

exports.newActiveQuiz = newActiveQuiz;

var associateItemAnalyses = function associateItemAnalyses(quizId, itemAnalyses) {
  return {
    type: _quizCommon.ASSOCIATE_ITEM_ANALYSES,
    payload: {
      quizId: quizId,
      itemAnalyses: itemAnalyses
    }
  };
};

exports.associateItemAnalyses = associateItemAnalyses;

var associateQuizAnalysis = function associateQuizAnalysis(quizId, quizAnalysis) {
  return {
    type: _quizCommon.ASSOCIATE_QUIZ_ANALYSIS,
    payload: {
      quizId: quizId,
      quizAnalysis: quizAnalysis
    }
  };
};

exports.associateQuizAnalysis = associateQuizAnalysis;

var associateQuizEntries = function associateQuizEntries(quizId, quizEntries) {
  return {
    type: _quizCommon.ASSOCIATE_QUIZ_ENTRIES,
    payload: {
      quizId: quizId,
      quizEntries: quizEntries
    }
  };
};

exports.associateQuizEntries = associateQuizEntries;

var disassociateQuizEntry = function disassociateQuizEntry(quizId, quizEntryId) {
  return {
    type: _quizCommon.DISASSOCIATE_QUIZ_ENTRY,
    payload: {
      quizId: quizId,
      quizEntryId: quizEntryId
    }
  };
};

exports.disassociateQuizEntry = disassociateQuizEntry;