"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiAlerts = require("@instructure/ui-alerts");

var _uiButtons = require("@instructure/ui-buttons");

var _uiElements = require("@instructure/ui-elements");

var _uiTabs = require("@instructure/ui-tabs");

var _uiToggleDetails = require("@instructure/ui-toggle-details");

var _uiForms = require("@instructure/ui-forms");

var _uiThemeable = require("@instructure/ui-themeable");

var _alertHelpers = require("../../../common/util/alertHelpers");

var _quizCommon = require("@instructure/quiz-common");

var _theme = _interopRequireDefault(require("./theme"));

var _ImportFileSelector = _interopRequireDefault(require("./ImportFileSelector"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'ceoks',
  template: function template(theme) {
    return "\n\n.ceoks_bOkE{margin-top:".concat(theme.altTextMargin || 'inherit', "}");
  },
  'altTextWrapper': 'ceoks_bOkE'
};
var ImportModal = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ImportModal, _Component);

  function ImportModal() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ImportModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ImportModal)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      selectedTabIndex: 0
    };

    _this.componentDidUpdate = function (prevProps, prevState) {
      if (!_this.props.modalOpen) {
        return;
      }

      var _this$props = _this.props,
          disableConfirm = _this$props.disableConfirm,
          uploadStatus = _this$props.uploadStatus;
      var isUploadSuccess = uploadStatus === _quizCommon.FILE_UPLOAD_SUCCESS && uploadStatus !== prevProps.uploadStatus;

      if (disableConfirm && isUploadSuccess) {
        _this.continueAction();
      }
    };

    _this.cancelAction = function () {
      _this.props.clearFiles();

      _this.props.clearAltText();

      if (_this.props.closeOverride) {
        // this timeout is needed because if this modal closes first,
        // then the ItemFeedbackModal will also close in the same click
        // since it will think the click happened "onOverlayClick"
        setTimeout(_this.props.closeOverride);
      } else {
        _this.props.closeModal();
      } // Wait for the modal to close before setting the status to prevent flashing
      // the select screen when closing the modal due to the modal having a gradual
      // fade transition that will display the change in state


      setTimeout(function () {
        return _this.props.setUploadStatus(_quizCommon.FILE_UPLOAD_SELECT);
      }, 300);
    };

    _this.errorAction = function () {
      return _this.props.setUploadStatus(_quizCommon.FILE_UPLOAD_ERROR);
    };

    _this.continueAction = function () {
      var uploadStatus = _this.props.uploadStatus;

      switch (uploadStatus) {
        case _quizCommon.FILE_UPLOAD_SUCCESS:
        case _quizCommon.FILE_UPLOAD_FAILURE:
          _this.cancelAction();

          break;

        case _quizCommon.FILE_UPLOAD_ERROR:
          _this.props.clearFiles();

          _this.props.clearAltText();

          _this.props.setUploadStatus(_quizCommon.FILE_UPLOAD_SELECT);

          break;

        default:
          _this.props.fileUpload(_this.props.files.get(0), _this.errorAction, _this.props.altText);

          _this.props.setUploadStatus(_quizCommon.FILE_UPLOAD_IMPORTING);

          _this.props.onContinue();

          break;
      }
    };

    _this.handleFile = function (file) {
      _this.props.receiveFile(file);

      _this.confirmButton.focus();
    };

    _this.onAltTextChange = function (e) {
      _this.props.setAltText(e.target.value);
    };

    _this.handleTabChange = function (event, _ref) {
      var index = _ref.index;

      _this.setState({
        selectedTabIndex: index
      });
    };

    return _this;
  }

  (0, _createClass2.default)(ImportModal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.uploadStatus === _quizCommon.FILE_UPLOAD_SUCCESS && this.props.modalOpen) {
        this.cancelAction();
      }
    }
  }, {
    key: "setRef",
    value: function setRef(refName) {
      var _this2 = this;

      return function (node) {
        _this2[refName] = node;
      };
    }
  }, {
    key: "disableCancelButton",
    value: function disableCancelButton() {
      var uploadStatus = this.props.uploadStatus;
      return [_quizCommon.FILE_UPLOAD_ERROR, _quizCommon.FILE_UPLOAD_FAILURE, _quizCommon.FILE_UPLOAD_SUCCESS].includes(uploadStatus);
    }
  }, {
    key: "cancelButton",
    value: function cancelButton() {
      return _react.default.createElement(_uiButtons.Button, {
        disabled: this.disableCancelButton(),
        onClick: this.cancelAction,
        margin: _quizCommon.XSMALL_SIDE_MARGIN,
        ref: this.setRef('cancelImportButton'),
        "data-automation": "sdk-cancel-import-button"
      }, (0, _formatMessage.default)('Cancel'));
    }
  }, {
    key: "disableContinueButton",
    value: function disableContinueButton() {
      var _this$props2 = this.props,
          uploadStatus = _this$props2.uploadStatus,
          files = _this$props2.files;
      return uploadStatus === _quizCommon.FILE_UPLOAD_IMPORTING || files.size === 0;
    }
  }, {
    key: "continueButtonMessage",
    value: function continueButtonMessage() {
      var uploadStatus = this.props.uploadStatus;

      switch (uploadStatus) {
        case _quizCommon.FILE_UPLOAD_FAILURE:
          return (0, _formatMessage.default)('Okay');

        case _quizCommon.FILE_UPLOAD_SUCCESS:
          return (0, _formatMessage.default)('Done');

        case _quizCommon.FILE_UPLOAD_ERROR:
          return (0, _formatMessage.default)('Start Over');

        default:
          return (0, _formatMessage.default)('Import');
      }
    }
  }, {
    key: "continueButton",
    value: function continueButton() {
      return _react.default.createElement(_uiButtons.Button, {
        onClick: this.continueAction,
        variant: "primary",
        disabled: this.disableContinueButton(),
        margin: _quizCommon.XSMALL_SIDE_MARGIN,
        ref: this.setRef('confirmButton'),
        "data-automation": "sdk-continue-import-button"
      }, this.continueButtonMessage());
    }
  }, {
    key: "renderErroredContent",
    value: function renderErroredContent() {
      return _react.default.createElement(_uiAlerts.Alert, {
        variant: "error",
        ref: this.setRef('errorAlert'),
        liveRegion: _alertHelpers.liveRegion
      }, (0, _formatMessage.default)('Error: there was a problem uploading your file.'));
    }
  }, {
    key: "renderSelectingContent",
    value: function renderSelectingContent(fileType) {
      return _react.default.createElement("div", null, _react.default.createElement("div", null, this.props.importMessage), _react.default.createElement(_ImportFileSelector.default, {
        files: this.props.files,
        ref: this.setRef('fileSelector'),
        receiveFile: this.handleFile,
        acceptAttribute: fileType,
        "data-automation": "sdk-import-file-selector"
      }), fileType === 'image/*' && _react.default.createElement("div", {
        className: styles.altTextWrapper
      }, _react.default.createElement(_uiForms.TextInput, {
        ref: this.setRef('altTextInput'),
        onChange: this.onAltTextChange,
        value: this.props.altText,
        label: _react.default.createElement("div", null, (0, _formatMessage.default)('alt text (optional)')),
        type: "text"
      })));
    }
  }, {
    key: "renderFailureContent",
    value: function renderFailureContent() {
      return _react.default.createElement("div", null, _react.default.createElement(_uiAlerts.Alert, {
        variant: "error",
        ref: this.setRef('failureAlert'),
        "data-automation": "sdk-import-error-alert",
        liveRegion: _alertHelpers.liveRegion
      }, _react.default.createElement("div", null, (0, _formatMessage.default)('Error: there was a problem importing your file.'), _react.default.createElement(_uiToggleDetails.ToggleDetails, {
        summary: _react.default.createElement(_uiElements.Text, {
          size: "small"
        }, (0, _formatMessage.default)('Error Details'))
      }, _react.default.createElement(_uiElements.Text, {
        size: "small"
      }, this.props.failureMessage)))));
    }
  }, {
    key: "renderSuccessContent",
    value: function renderSuccessContent() {
      var file = this.props.files.get(0);
      var fileName = file ? file.name : '';
      return _react.default.createElement(_uiAlerts.Alert, {
        variant: "success",
        ref: this.setRef('successAlert'),
        "data-automation": "sdk-import-success-alert",
        liveRegion: _alertHelpers.liveRegion
      }, (0, _formatMessage.default)('Success: {fileName} has imported successfully!', {
        fileName: fileName
      }));
    }
  }, {
    key: "renderImportingContent",
    value: function renderImportingContent() {
      return _react.default.createElement(_uiElements.Progress, {
        label: (0, _formatMessage.default)('Import process completion'),
        valueNow: this.props.progressValue,
        ref: this.setRef('progressBar')
      });
    }
  }, {
    key: "renderImportContent",
    value: function renderImportContent(fileType) {
      var uploadStatus = this.props.uploadStatus;

      switch (uploadStatus) {
        case _quizCommon.FILE_UPLOAD_FAILURE:
          return this.renderFailureContent();

        case _quizCommon.FILE_UPLOAD_SUCCESS:
          return this.renderSuccessContent();

        case _quizCommon.FILE_UPLOAD_ERROR:
          return this.renderErroredContent();

        case _quizCommon.FILE_UPLOAD_IMPORTING:
          return this.renderImportingContent();

        default:
          return this.renderSelectingContent(fileType);
      }
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this3 = this;

      if (typeof this.props.acceptFileType === 'string') {
        return this.renderImportContent(this.props.acceptFileType);
      }

      var selectedIndex = this.state.selectedTabIndex;
      return _react.default.createElement(_uiTabs.Tabs, {
        onRequestTabChange: this.handleTabChange,
        variant: "secondary"
      }, this.props.acceptFileType.map(function (_ref2, index) {
        var fileType = _ref2.fileType,
            title = _ref2.title;
        return _react.default.createElement(_uiTabs.Tabs.Panel, {
          key: title,
          renderTitle: title,
          disabled: _this3.props.files.size > 0 && index !== selectedIndex,
          isSelected: selectedIndex === index
        }, _this3.renderImportContent(fileType));
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_quizCommon.Modal, {
        open: this.props.modalOpen,
        size: "small",
        onClose: this.props.onClose,
        onDismiss: this.cancelAction,
        label: (0, _formatMessage.default)('Import Content'),
        ref: this.setRef('modal'),
        "data-automation": "sdk-import-content-modal"
      }, _react.default.createElement(_quizCommon.ModalHeader, null, _react.default.createElement(_uiElements.Heading, {
        level: "reset",
        as: "h2"
      }, (0, _formatMessage.default)('Import Content')), _react.default.createElement(_uiButtons.CloseButton, {
        onClick: this.cancelAction,
        placement: "end",
        offset: "medium",
        variant: "icon"
      }, (0, _formatMessage.default)('Close'))), _react.default.createElement(_quizCommon.ModalBody, null, this.renderContent()), _react.default.createElement(_quizCommon.ModalFooter, null, this.cancelButton(), this.continueButton()));
    }
  }]);
  ImportModal.displayName = "ImportModal";
  return ImportModal;
}(_react.Component), _class2.propTypes = {
  acceptFileType: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.shape({
    fileType: _propTypes.default.string,
    title: _propTypes.default.string
  }))]).isRequired,
  altText: _propTypes.default.string.isRequired,
  // passed in by connect
  clearAltText: _propTypes.default.func.isRequired,
  // passed in by connect
  clearFiles: _propTypes.default.func.isRequired,
  // passed in by connect
  closeModal: _propTypes.default.func.isRequired,
  // passed in by connect
  closeOverride: _propTypes.default.func,
  disableConfirm: _propTypes.default.bool,
  failureMessage: _propTypes.default.string.isRequired,
  files: _reactImmutableProptypes.default.list.isRequired,
  // passed in by connect
  fileUpload: _propTypes.default.func.isRequired,
  importMessage: _propTypes.default.string.isRequired,
  modalOpen: _propTypes.default.bool.isRequired,
  // passed in by connect
  onClose: _propTypes.default.func,
  onContinue: _propTypes.default.func.isRequired,
  progressValue: _propTypes.default.number.isRequired,
  receiveFile: _propTypes.default.func.isRequired,
  // passed in by connect
  setAltText: _propTypes.default.func.isRequired,
  // passed in by connect
  setUploadStatus: _propTypes.default.func.isRequired,
  // passed in by connect
  uploadStatus: _propTypes.default.oneOf([_quizCommon.FILE_UPLOAD_SELECT, _quizCommon.FILE_UPLOAD_IMPORTING, _quizCommon.FILE_UPLOAD_SUCCESS, _quizCommon.FILE_UPLOAD_FAILURE, _quizCommon.FILE_UPLOAD_ERROR]).isRequired // passed in by connect

}, _class2.defaultProps = {
  closeOverride: null,
  disableConfirm: false,
  onClose: function onClose() {}
}, _temp)) || _class);
exports.default = ImportModal;