"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _uiButtons = require("@instructure/ui-buttons");

var _uiA11y = require("@instructure/ui-a11y");

var _uiIcons = require("@instructure/ui-icons");

var _LearnosityCalculator = _interopRequireDefault(require("../../../LearnosityCalculator"));

var CalculatorButton = function CalculatorButton(_ref) {
  var toggleCalculator = _ref.toggleCalculator,
      enabled = _ref.enabled;
  return _react.default.createElement(_uiButtons.Button, {
    icon: _uiIcons.IconCalculatorLine,
    onClick: toggleCalculator,
    disabled: !enabled
  }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Calculator')));
};

CalculatorButton.propTypes = {
  toggleCalculator: _propTypes.default.func.isRequired,
  enabled: _propTypes.default.bool.isRequired
};

var Calculator =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Calculator, _Component);

  function Calculator() {
    (0, _classCallCheck2.default)(this, Calculator);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Calculator).apply(this, arguments));
  }

  (0, _createClass2.default)(Calculator, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_LearnosityCalculator.default, Object.assign({}, this.props, {
        render: CalculatorButton
      }));
    }
  }]);
  Calculator.displayName = "Calculator";
  return Calculator;
}(_react.Component);

exports.default = Calculator;
Calculator.propTypes = {
  activeCalculatorId: _propTypes.default.string,
  calculatorType: _propTypes.default.oneOf(['none', 'basic', 'scientific']),
  quizSessionId: _propTypes.default.string,
  setActiveCalculatorId: _propTypes.default.func.isRequired
};
Calculator.defaultProps = {
  activeCalculatorId: void 0,
  calculatorType: void 0,
  quizSessionId: void 0
};