"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _quizCommon = require("@instructure/quiz-common");

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : (0, _immutable.fromJS)({
    OPEN_ADD_CONTENT_MODAL_DATA: {
      allowStimulusCreation: false,
      modalOpen: false,
      position: 0,
      quizId: '',
      stimulusId: ''
    }
  });
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _quizCommon.OPEN_DELETE_STIMULUS_MODAL:
      return state.set('isOpen', _quizCommon.DELETE_STIMULUS_MODAL);

    case _quizCommon.OPEN_ADD_CONTENT_MODAL:
      return state.set('isOpen', _quizCommon.ADD_CONTENT_MODAL).set(_quizCommon.OPEN_ADD_CONTENT_MODAL_DATA, (0, _immutable.Map)(action.payload));

    case _quizCommon.OPEN_MOVE_IMMUTABLE_MODAL:
      return state.set('isOpen', _quizCommon.MOVE_IMMUTABLE_MODAL);

    case _quizCommon.OPEN_MODAL:
      return state.set('isOpen', action.payload.title).set('options', (0, _immutable.Map)(action.payload.options));

    case _quizCommon.CLOSE_MODAL:
      return state.set('isOpen', false);

    default:
      return state;
  }
};

exports.default = _default;