"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiForms = require("@instructure/ui-forms");

var _uiLayout = require("@instructure/ui-layout");

var _TimeUnitsInput = _interopRequireDefault(require("../../../../../common/components/shared/TimeUnitsInput"));

var _ExtraTimeMultiplier = _interopRequireDefault(require("../ExtraTimeMultiplier"));

var _FormattedDuration = require("../../../../../common/components/shared/FormattedDuration");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getTimeAdjustmentType = function getTimeAdjustmentType(timerSettings) {
  if (timerSettings.timerMultiplierEnabled) {
    return 'timerMultiplierEnabled';
  }

  if (timerSettings.extraTimeEnabled) {
    return 'extraTimeEnabled';
  }

  if (timerSettings.disableTimer) {
    return 'disableTimer';
  }

  return 'none';
};

var ExtraTimeSettings =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ExtraTimeSettings, _Component);

  function ExtraTimeSettings() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ExtraTimeSettings);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ExtraTimeSettings)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.onChangeTimeAdjustmentType = function (event, _ref) {
      var value = _ref.value;
      var timeAdjustments = {
        timerMultiplierEnabled: false,
        extraTimeEnabled: false,
        disableTimer: false
      };

      if (value !== 'none') {
        timeAdjustments[value] = true;
      }

      _this.props.onChange(_objectSpread({}, _this.props.timerSettings, {}, timeAdjustments));
    };

    _this.onChangeExtraSeconds = function (seconds) {
      var update = _objectSpread({}, _this.props.timerSettings, {
        extraTimeInSeconds: seconds
      });

      _this.props.onChange(update);
    };

    _this.onChangeMultiplier = function (multiplier) {
      var update = _objectSpread({}, _this.props.timerSettings, {
        timerMultiplierValue: multiplier
      });

      _this.props.onChange(update);
    };

    return _this;
  }

  (0, _createClass2.default)(ExtraTimeSettings, [{
    key: "render",
    value: function render() {
      var timerSettings = this.props.timerSettings;
      var timeAdjustmentType = getTimeAdjustmentType(timerSettings);
      return _react.default.createElement(_uiLayout.View, {
        display: "block",
        margin: "medium none"
      }, _react.default.createElement(_uiForms.Select, {
        label: (0, _formatMessage.default)('Time adjustments'),
        assistiveText: (0, _formatMessage.default)('4 options available. Use arrow keys to navigate options.'),
        selectedOption: timeAdjustmentType,
        onChange: this.onChangeTimeAdjustmentType,
        "data-automation": "sdk-moderation-time-dropdown"
      }, _react.default.createElement("option", {
        value: "none"
      }, (0, _formatMessage.default)('None')), _react.default.createElement("option", {
        value: "extraTimeEnabled"
      }, (0, _formatMessage.default)('Give additional time')), _react.default.createElement("option", {
        value: "disableTimer"
      }, (0, _formatMessage.default)('Remove time limit (unlimited)')), _react.default.createElement("option", {
        value: "timerMultiplierEnabled"
      }, (0, _formatMessage.default)('Time limit multiplier'))), timeAdjustmentType === 'extraTimeEnabled' && _react.default.createElement(_TimeUnitsInput.default, {
        onChange: this.onChangeExtraSeconds,
        timeInSeconds: timerSettings.extraTimeInSeconds,
        maxTimeInSeconds: this.props.maxTimeInSeconds,
        hoursLabel: (0, _formatMessage.default)('Hours'),
        hoursDataAutomation: "sdk-moderation-time-hours",
        minutesLabel: (0, _formatMessage.default)('Minutes'),
        minutesDataAutomation: "sdk-moderation-time-minutes",
        description: (0, _formatMessage.default)('Additional time'),
        margin: "medium none"
      }), timeAdjustmentType === 'timerMultiplierEnabled' && _react.default.createElement(_ExtraTimeMultiplier.default, {
        onChange: this.onChangeMultiplier,
        timerMultiplierValue: timerSettings.timerMultiplierValue,
        maxMultiplier: this.props.maxMultiplier,
        minMultiplier: this.props.minMultiplier
      }));
    }
  }]);
  ExtraTimeSettings.displayName = "ExtraTimeSettings";
  return ExtraTimeSettings;
}(_react.Component);

ExtraTimeSettings.propTypes = {
  timerSettings: _propTypes.default.shape({
    disableTimer: _propTypes.default.bool,
    extraTimeEnabled: _propTypes.default.bool,
    extraTimeInSeconds: _propTypes.default.number,
    increaseTimeAllowance: _propTypes.default.bool,
    timerMultiplierEnabled: _propTypes.default.bool,
    timerMultiplierValue: _propTypes.default.number
  }).isRequired,
  onChange: _propTypes.default.func.isRequired,
  maxTimeInSeconds: _propTypes.default.number,
  maxMultiplier: _propTypes.default.number,
  minMultiplier: _propTypes.default.number
};
ExtraTimeSettings.defaultProps = {
  maxTimeInSeconds: 168 * _FormattedDuration.HOUR_IN_SECONDS,
  maxMultiplier: 99,
  minMultiplier: 1
};
var _default = ExtraTimeSettings;
exports.default = _default;